diff -r f6ef988fda71 trytond/tests/test_trigger.py
--- a/trytond/tests/test_trigger.py	Fri Sep 21 16:04:02 2012 +0200
+++ b/trytond/tests/test_trigger.py	Sun Sep 23 17:30:03 2012 +0200
@@ -49,18 +49,18 @@
         '''
         with Transaction().start(DB_NAME, USER,
                 context=CONTEXT) as transaction:
-            model_id = self.model.search([
-                ('model', '=', 'test.triggered'),
-                ])[0]
+            model, = self.model.search([
+                    ('model', '=', 'test.triggered'),
+                    ])
 
             values = {
                 'name': 'Test',
-                'model': model_id,
+                'model': model.id,
                 'on_time': True,
                 'condition': 'True',
-                'action_model': model_id,
+                'action_model': model.id,
                 'action_function': 'test',
-            }
+                }
             self.assert_(self.trigger.create(values))
 
             # on_exclusive
@@ -70,17 +70,17 @@
                     combination_values = values.copy()
                     for mode in combination:
                         combination_values['on_%s' % mode] = True
-                    self.failUnlessRaises(Exception, self.trigger.create,
-                            combination_values)
+                    self.assertRaises(Exception, self.trigger.create,
+                        combination_values)
 
             # check_condition
             condition_values = values.copy()
             condition_values['condition'] = '='
-            self.failUnlessRaises(Exception, self.trigger.create,
-                    condition_values)
+            self.assertRaises(Exception, self.trigger.create,
+                condition_values)
 
             # Restart the cache on the get_triggers method of ir.trigger
-            self.trigger.get_triggers.reset()
+            self.trigger._get_triggers_cache.clear()
             transaction.cursor.rollback()
 
     def test0020on_create(self):
@@ -89,68 +89,68 @@
         '''
         with Transaction().start(DB_NAME, USER,
                 context=CONTEXT) as transaction:
-            model_id = self.model.search([
-                ('model', '=', 'test.triggered'),
-                ])[0]
+            model, = self.model.search([
+                    ('model', '=', 'test.triggered'),
+                    ])
 
-            trigger_id = self.trigger.create({
-                'name': 'Test',
-                'model': model_id,
-                'on_create': True,
-                'condition': 'True',
-                'action_model': model_id,
-                'action_function': 'trigger',
-                })
+            trigger = self.trigger.create({
+                    'name': 'Test',
+                    'model': model.id,
+                    'on_create': True,
+                    'condition': 'True',
+                    'action_model': model.id,
+                    'action_function': 'trigger',
+                    })
 
-            triggered_id = self.triggered.create({
-                'name': 'Test',
-                })
+            triggered = self.triggered.create({
+                    'name': 'Test',
+                    })
 
-            self.assert_(TRIGGER_LOGS == [([triggered_id], trigger_id)])
+            self.assertEqual(TRIGGER_LOGS, [([triggered], trigger)])
             TRIGGER_LOGS.pop()
 
             # Trigger with condition
-            self.trigger.write(trigger_id, {
-                'condition': 'self.name == "Bar"',
-                })
+            self.trigger.write([trigger], {
+                    'condition': 'self.name == "Bar"',
+                    })
 
             # Matching condition
-            triggered_id = self.triggered.create({
-                'name': 'Bar',
-                })
-            self.assert_(TRIGGER_LOGS == [([triggered_id], trigger_id)])
+            triggered = self.triggered.create({
+                    'name': 'Bar',
+                    })
+            self.assertEqual(TRIGGER_LOGS, [([triggered], trigger)])
             TRIGGER_LOGS.pop()
 
             # Non matching condition
-            triggered_id = self.triggered.create({
-                'name': 'Foo',
-                })
-            self.assert_(TRIGGER_LOGS == [])
+            triggered = self.triggered.create({
+                    'name': 'Foo',
+                    })
+            self.assertEqual(TRIGGER_LOGS, [])
 
             # With limit number
-            self.trigger.write(trigger_id, {
-                'condition': 'True',
-                'limit_number': 1,
-                })
-            triggered_id = self.triggered.create({
-                'name': 'Test',
-                })
-            self.assert_(TRIGGER_LOGS == [([triggered_id], trigger_id)])
+            self.trigger.write([trigger], {
+                    'condition': 'True',
+                    'limit_number': 1,
+                    })
+            triggered = self.triggered.create({
+                    'name': 'Test',
+                    })
+            self.assertEqual(TRIGGER_LOGS, [([triggered], trigger)])
             TRIGGER_LOGS.pop()
 
             # With minimum delay
-            self.trigger.write(trigger_id, {
-                'limit_number': 0,
-                'minimum_delay': 1,
-                })
-            triggered_id = self.triggered.create({
-                'name': 'Test',
-                })
-            self.assert_(TRIGGER_LOGS == [([triggered_id], trigger_id)])
+            self.trigger.write([trigger], {
+                    'limit_number': 0,
+                    'minimum_delay': 1,
+                    })
+            triggered = self.triggered.create({
+                    'name': 'Test',
+                    })
+            self.assertEqual(TRIGGER_LOGS, [([triggered], trigger)])
             TRIGGER_LOGS.pop()
 
             # Restart the cache on the get_triggers method of ir.trigger
-            self.trigger.get_triggers.reset()
+            self.trigger._get_triggers_cache.clear()
             transaction.cursor.rollback()
 
     def test0030on_write(self):
@@ -159,108 +159,108 @@
         '''
         with Transaction().start(DB_NAME, USER,
                 context=CONTEXT) as transaction:
-            model_id = self.model.search([
-                ('model', '=', 'test.triggered'),
-                ])[0]
+            model, = self.model.search([
+                    ('model', '=', 'test.triggered'),
+                    ])
 
-            trigger_id = self.trigger.create({
-                'name': 'Test',
-                'model': model_id,
-                'on_write': True,
-                'condition': 'True',
-                'action_model': model_id,
-                'action_function': 'trigger',
-                })
+            trigger = self.trigger.create({
+                    'name': 'Test',
+                    'model': model.id,
+                    'on_write': True,
+                    'condition': 'True',
+                    'action_model': model.id,
+                    'action_function': 'trigger',
+                    })
 
-            triggered_id = self.triggered.create({
-                'name': 'Test',
-                })
+            triggered = self.triggered.create({
+                    'name': 'Test',
+                    })
 
-            self.triggered.write(triggered_id, {
-                'name': 'Foo',
-                })
-            self.assert_(TRIGGER_LOGS == [])
+            self.triggered.write([triggered], {
+                    'name': 'Foo',
+                    })
+            self.assertEqual(TRIGGER_LOGS, [])
 
             # Trigger with condition
-            self.trigger.write(trigger_id, {
-                'condition': 'self.name == "Bar"',
-                })
+            self.trigger.write([trigger], {
+                    'condition': 'self.name == "Bar"',
+                    })
 
             # Matching condition
-            self.triggered.write(triggered_id, {
-                'name': 'Bar',
-                })
-            self.assert_(TRIGGER_LOGS == [([triggered_id], trigger_id)])
+            self.triggered.write([triggered], {
+                    'name': 'Bar',
+                    })
+            self.assertEqual(TRIGGER_LOGS, [([triggered], trigger)])
             TRIGGER_LOGS.pop()
 
             # No change in condition
-            self.triggered.write(triggered_id, {
-                'name': 'Bar',
-                })
-            self.assert_(TRIGGER_LOGS == [])
+            self.triggered.write([triggered], {
+                    'name': 'Bar',
+                    })
+            self.assertEqual(TRIGGER_LOGS, [])
 
             # Different change in condition
-            self.triggered.write(triggered_id, {
-                'name': 'Foo',
-                })
-            self.assert_(TRIGGER_LOGS == [])
+            self.triggered.write([triggered], {
+                    'name': 'Foo',
+                    })
+            self.assertEqual(TRIGGER_LOGS, [])
 
             # With limit number
-            self.trigger.write(trigger_id, {
-                'condition': 'self.name == "Bar"',
-                'limit_number': 1,
-                })
-            triggered_id = self.triggered.create({
-                'name': 'Foo',
-                })
-            self.triggered.write(triggered_id, {
-                'name': 'Bar',
-                })
-            self.triggered.write(triggered_id, {
-                'name': 'Foo',
-                })
-            self.triggered.write(triggered_id, {
-                'name': 'Bar',
-                })
-            self.assert_(TRIGGER_LOGS == [([triggered_id], trigger_id)])
+            self.trigger.write([trigger], {
+                    'condition': 'self.name == "Bar"',
+                    'limit_number': 1,
+                    })
+            triggered = self.triggered.create({
+                    'name': 'Foo',
+                    })
+            self.triggered.write([triggered], {
+                    'name': 'Bar',
+                    })
+            self.triggered.write([triggered], {
+                    'name': 'Foo',
+                    })
+            self.triggered.write([triggered], {
+                    'name': 'Bar',
+                    })
+            self.assertEqual(TRIGGER_LOGS, [([triggered], trigger)])
             TRIGGER_LOGS.pop()
 
             # With minimum delay
-            self.trigger.write(trigger_id, {
-                'limit_number': 0,
-                'minimum_delay': MAXINT,
-                })
-            triggered_id = self.triggered.create({
-                'name': 'Foo',
-                })
+            self.trigger.write([trigger], {
+                    'limit_number': 0,
+                    'minimum_delay': MAXINT,
+                    })
+            triggered = self.triggered.create({
+                    'name': 'Foo',
+                    })
             for name in ('Bar', 'Foo', 'Bar'):
-                self.triggered.write(triggered_id, {
-                    'name': name,
-                    })
-            self.assert_(TRIGGER_LOGS == [([triggered_id], trigger_id)])
+                self.triggered.write([triggered], {
+                        'name': name,
+                        })
+            self.assertEqual(TRIGGER_LOGS, [([triggered], trigger)])
             TRIGGER_LOGS.pop()
 
-            self.trigger.write(trigger_id, {
-                'minimum_delay': 0.02,
-                })
-            triggered_id = self.triggered.create({
-                'name': 'Foo',
-                })
+            self.trigger.write([trigger], {
+                    'minimum_delay': 0.02,
+                    })
+            triggered = self.triggered.create({
+                    'name': 'Foo',
+                    })
             for name in ('Bar', 'Foo'):
-                self.triggered.write(triggered_id, {
-                    'name': name,
+                self.triggered.write([triggered], {
+                        'name': name,
+                        })
+            time.sleep(1.2)
+            self.triggered.write([triggered], {
+                    'name': 'Bar',
                     })
-            time.sleep(1.2)
-            self.triggered.write(triggered_id, {
-                'name': 'Bar',
-                })
-            self.assert_(TRIGGER_LOGS == [([triggered_id], trigger_id),
-                ([triggered_id], trigger_id)])
+            self.assertEqual(TRIGGER_LOGS,
+                [([triggered], trigger), ([triggered], trigger)])
             TRIGGER_LOGS.pop()
             TRIGGER_LOGS.pop()
 
             # Restart the cache on the get_triggers method of ir.trigger
-            self.trigger.get_triggers.reset()
+            self.trigger._get_triggers_cache.clear()
             transaction.cursor.rollback()
 
     def test0040on_delete(self):
@@ -269,86 +269,86 @@
         '''
         with Transaction().start(DB_NAME, USER,
                 context=CONTEXT) as transaction:
-            model_id = self.model.search([
-                ('model', '=', 'test.triggered'),
-                ])[0]
+            model, = self.model.search([
+                    ('model', '=', 'test.triggered'),
+                    ])
 
-            triggered_id = self.triggered.create({
-                'name': 'Test',
-                })
+            triggered = self.triggered.create({
+                    'name': 'Test',
+                    })
 
-            trigger_id = self.trigger.create({
-                'name': 'Test',
-                'model': model_id,
-                'on_delete': True,
-                'condition': 'True',
-                'action_model': model_id,
-                'action_function': 'trigger',
-                })
+            trigger = self.trigger.create({
+                    'name': 'Test',
+                    'model': model.id,
+                    'on_delete': True,
+                    'condition': 'True',
+                    'action_model': model.id,
+                    'action_function': 'trigger',
+                    })
 
-            self.triggered.delete(triggered_id)
-            self.assert_(TRIGGER_LOGS == [([triggered_id], trigger_id)])
+            self.triggered.delete([triggered])
+            self.assertEqual(TRIGGER_LOGS, [([triggered], trigger)])
             TRIGGER_LOGS.pop()
             Transaction().delete = {}
 
             # Trigger with condition
-            self.trigger.write(trigger_id, {
-                'condition': 'self.name == "Bar"',
-                })
+            self.trigger.write([trigger], {
+                    'condition': 'self.name == "Bar"',
+                    })
 
-            triggered_id = self.triggered.create({
-                'name': 'Bar',
-                })
+            triggered = self.triggered.create({
+                    'name': 'Bar',
+                    })
 
             # Matching condition
-            self.triggered.delete(triggered_id)
-            self.assert_(TRIGGER_LOGS == [([triggered_id], trigger_id)])
+            self.triggered.delete([triggered])
+            self.assertEqual(TRIGGER_LOGS, [([triggered], trigger)])
             TRIGGER_LOGS.pop()
             Transaction().delete = {}
 
-            triggered_id = self.triggered.create({
-                'name': 'Foo',
-                })
+            triggered = self.triggered.create({
+                    'name': 'Foo',
+                    })
 
             # Non matching condition
-            self.triggered.delete(triggered_id)
-            self.assert_(TRIGGER_LOGS == [])
+            self.triggered.delete([triggered])
+            self.assertEqual(TRIGGER_LOGS, [])
             Transaction().delete = {}
 
-            triggered_id = self.triggered.create({
-                'name': 'Test',
-                })
+            triggered = self.triggered.create({
+                    'name': 'Test',
+                    })
 
             # With limit number
-            self.trigger.write(trigger_id, {
-                'condition': 'True',
-                'limit_number': 1,
-                })
-            self.triggered.delete(triggered_id)
-            self.assert_(TRIGGER_LOGS == [([triggered_id], trigger_id)])
+            self.trigger.write([trigger], {
+                    'condition': 'True',
+                    'limit_number': 1,
+                    })
+            self.triggered.delete([triggered])
+            self.assertEqual(TRIGGER_LOGS, [([triggered], trigger)])
             TRIGGER_LOGS.pop()
             Transaction().delete = {}
             # Delete trigger logs because SQLite reuse the same triggered_id
             self.trigger_log.delete(self.trigger_log.search([
-                        ('trigger', '=', trigger_id),
+                        ('trigger', '=', trigger.id),
                         ]))
 
-            triggered_id = self.triggered.create({
-                'name': 'Test',
-                })
+            triggered = self.triggered.create({
+                    'name': 'Test',
+                    })
 
             # With minimum delay
-            self.trigger.write(trigger_id, {
-                'limit_number': 0,
-                'minimum_delay': 1,
-                })
-            self.triggered.delete(triggered_id)
-            self.assert_(TRIGGER_LOGS == [([triggered_id], trigger_id)])
+            self.trigger.write([trigger], {
+                    'limit_number': 0,
+                    'minimum_delay': 1,
+                    })
+            self.triggered.delete([triggered])
+            self.assertEqual(TRIGGER_LOGS, [([triggered], trigger)])
             TRIGGER_LOGS.pop()
             Transaction().delete = {}
 
             # Restart the cache on the get_triggers method of ir.trigger
-            self.trigger.get_triggers.reset()
+            self.trigger._get_triggers_cache.clear()
             transaction.cursor.rollback()
 
     def test0050on_time(self):
@@ -357,91 +357,91 @@
         '''
         with Transaction().start(DB_NAME, USER,
                 context=CONTEXT) as transaction:
-            model_id = self.model.search([
-                ('model', '=', 'test.triggered'),
-                ])[0]
+            model, = self.model.search([
+                    ('model', '=', 'test.triggered'),
+                    ])
 
-            trigger_id = self.trigger.create({
-                'name': 'Test',
-                'model': model_id,
-                'on_time': True,
-                'condition': 'True',
-                'action_model': model_id,
-                'action_function': 'trigger',
-                })
+            trigger = self.trigger.create({
+                    'name': 'Test',
+                    'model': model.id,
+                    'on_time': True,
+                    'condition': 'True',
+                    'action_model': model.id,
+                    'action_function': 'trigger',
+                    })
 
-            triggered_id = self.triggered.create({
-                'name': 'Test',
-                })
+            triggered = self.triggered.create({
+                    'name': 'Test',
+                    })
             self.trigger.trigger_time()
-            self.assert_(TRIGGER_LOGS == [([triggered_id], trigger_id)])
+            self.assert_(TRIGGER_LOGS == [([triggered], trigger)])
             TRIGGER_LOGS.pop()
 
             # Trigger with condition
-            self.trigger.write(trigger_id, {
-                'condition': 'self.name == "Bar"',
-                })
+            self.trigger.write([trigger], {
+                    'condition': 'self.name == "Bar"',
+                    })
 
             # Matching condition
-            self.triggered.write(triggered_id, {
-                'name': 'Bar',
-                })
+            self.triggered.write([triggered], {
+                    'name': 'Bar',
+                    })
             self.trigger.trigger_time()
-            self.assert_(TRIGGER_LOGS == [([triggered_id], trigger_id)])
+            self.assert_(TRIGGER_LOGS == [([triggered], trigger)])
             TRIGGER_LOGS.pop()
 
             # Non matching condition
-            self.triggered.write(triggered_id, {
-                'name': 'Foo',
-                })
+            self.triggered.write([triggered], {
+                    'name': 'Foo',
+                    })
             self.trigger.trigger_time()
             self.assert_(TRIGGER_LOGS == [])
 
             # With limit number
-            self.trigger.write(trigger_id, {
-                'condition': 'True',
-                'limit_number': 1,
-                })
+            self.trigger.write([trigger], {
+                    'condition': 'True',
+                    'limit_number': 1,
+                    })
             self.trigger.trigger_time()
             self.trigger.trigger_time()
-            self.assert_(TRIGGER_LOGS == [([triggered_id], trigger_id)])
+            self.assert_(TRIGGER_LOGS == [([triggered], trigger)])
             TRIGGER_LOGS.pop()
 
             # Delete trigger logs of limit number test
             self.trigger_log.delete(self.trigger_log.search([
-                        ('trigger', '=', trigger_id),
+                        ('trigger', '=', trigger.id),
                         ]))
 
             # With minimum delay
-            self.trigger.write(trigger_id, {
-                'limit_number': 0,
-                'minimum_delay': MAXINT,
-                })
+            self.trigger.write([trigger], {
+                    'limit_number': 0,
+                    'minimum_delay': MAXINT,
+                    })
             self.trigger.trigger_time()
             self.trigger.trigger_time()
-            self.assert_(TRIGGER_LOGS == [([triggered_id], trigger_id)])
+            self.assert_(TRIGGER_LOGS == [([triggered], trigger)])
             TRIGGER_LOGS.pop()
             Transaction().delete = {}
 
             # Delete trigger logs of previous minimum delay test
             self.trigger_log.delete(self.trigger_log.search([
-                ('trigger', '=', trigger_id),
-                ]))
+                        ('trigger', '=', trigger.id),
+                        ]))
 
-            self.trigger.write(trigger_id, {
-                'minimum_delay': 0.02,
-                })
+            self.trigger.write([trigger], {
+                    'minimum_delay': 0.02,
+                    })
             self.trigger.trigger_time()
             time.sleep(1.2)
             self.trigger.trigger_time()
-            self.assert_(TRIGGER_LOGS == [([triggered_id], trigger_id),
-                ([triggered_id], trigger_id)])
+            self.assert_(TRIGGER_LOGS == [([triggered], trigger),
+                    ([triggered], trigger)])
             TRIGGER_LOGS.pop()
             TRIGGER_LOGS.pop()
             Transaction().delete = {}
 
             # Restart the cache on the get_triggers method of ir.trigger
-            self.trigger.get_triggers.reset()
+            self.trigger._get_triggers_cache.clear()
             transaction.cursor.rollback()
 
 
diff -r f6ef988fda71 trytond/tests/test_tryton.py
--- a/trytond/tests/test_tryton.py	Fri Sep 21 16:04:02 2012 +0200
+++ b/trytond/tests/test_tryton.py	Sun Sep 23 17:30:03 2012 +0200
@@ -41,14 +41,13 @@
 if not CONFIG['admin_passwd']:
     CONFIG['admin_passwd'] = 'admin'
 
-from trytond.modules import register_classes
 from trytond.pool import Pool
 from trytond.backend import Database
 from trytond.protocols.dispatcher import create
 from trytond.transaction import Transaction
 from trytond.pyson import PYSONEncoder, Eval
 
-register_classes()
+Pool.start()
 
 if CONFIG['db_type'] == 'sqlite':
     DB_NAME = ':memory:'
@@ -121,27 +120,29 @@
         create(DB_NAME, CONFIG['admin_passwd'], 'en_US', USER_PASSWORD)
     with Transaction().start(DB_NAME, USER,
             context=CONTEXT) as transaction:
-        module_obj = POOL.get('ir.module.module')
+        Module = POOL.get('ir.module.module')
 
-        module_ids = module_obj.search([
-            ('name', '=', name),
-            ])
-        assert module_ids
+        modules = Module.search([
+                ('name', '=', name),
+                ])
+        assert modules
 
-        module_ids = module_obj.search([
-            ('name', '=', name),
-            ('state', '!=', 'installed'),
-            ])
+        modules = Module.search([
+                ('name', '=', name),
+                ('state', '!=', 'installed'),
+                ])
 
-        if not module_ids:
+        if not modules:
             return
 
-        module_obj.install(module_ids)
+        Module.install(modules)
         transaction.cursor.commit()
 
-        install_upgrade_obj = POOL.get('ir.module.module.install_upgrade',
-                type='wizard')
-        install_upgrade_obj.transition_upgrade(None)
+        InstallUpgrade = POOL.get('ir.module.module.install_upgrade',
+            type='wizard')
+        instance_id, _, _ = InstallUpgrade.create()
+        InstallUpgrade(instance_id).transition_upgrade()
+        InstallUpgrade.delete(instance_id)
         transaction.cursor.commit()
 
 
@@ -151,17 +152,17 @@
     '''
     with Transaction().start(DB_NAME, USER,
             context=CONTEXT) as transaction:
-        view_obj = POOL.get('ir.ui.view')
-        view_ids = view_obj.search([
-            ('module', '=', module_name),
-            ('model', '!=', ''),
-            ])
-        assert view_ids, "No views for %s" % module_name
-        for view in view_obj.browse(view_ids):
+        View = POOL.get('ir.ui.view')
+        views = View.search([
+                ('module', '=', module_name),
+                ('model', '!=', ''),
+                ])
+        assert views, "No views for %s" % module_name
+        for view in views:
             view_id = view.inherit and view.inherit.id or view.id
             model = view.model
-            model_obj = POOL.get(model)
-            res = model_obj.fields_view_get(view_id)
+            Model = POOL.get(model)
+            res = Model.fields_view_get(view_id)
             assert res['model'] == model
             tree = etree.fromstring(res['arch'])
             tree_root = tree.getroottree().getroot()
@@ -195,7 +196,7 @@
 
     with Transaction().start(DB_NAME, USER, context=CONTEXT):
         for mname, model in Pool().iterobject():
-            for fname, field in model._columns.iteritems():
+            for fname, field in model._fields.iteritems():
                 encoder = Encoder()
                 encoder.encode(field.domain)
                 if hasattr(field, 'digits'):
diff -r f6ef988fda71 trytond/tests/test_wizard.py
--- a/trytond/tests/test_wizard.py	Fri Sep 21 16:04:02 2012 +0200
+++ b/trytond/tests/test_wizard.py	Sun Sep 23 17:30:03 2012 +0200
@@ -4,7 +4,6 @@
 from trytond.tests.test_tryton import (POOL, DB_NAME, USER, CONTEXT,
     install_module)
 from trytond.transaction import Transaction
-from trytond.wizard import Session
 
 
 class WizardTestCase(unittest.TestCase):
@@ -13,6 +12,7 @@
         install_module('test')
         self.wizard = POOL.get('test.test_wizard', type='wizard')
         self.session = POOL.get('ir.session.wizard')
+        self.group = POOL.get('res.group')
 
     def test0010create(self):
         'Create Session Wizard'
@@ -32,17 +32,27 @@
         'Session Wizard'
         with Transaction().start(DB_NAME, USER, CONTEXT):
             session_id = self.session.create({})
-            session = Session(self.wizard, session_id)
-            self.assertEqual(session.start.name, None)
+            session = self.wizard(session_id)
+            self.assertEqual(session.start.id, None)
+            self.assertRaises(AttributeError, getattr, session.start, 'name')
+            self.assertEqual(hasattr(session.start, 'name'), False)
             session.start.name = 'Test'
-            self.assertEqual(session.start.user.id, None)
+            self.assertRaises(AttributeError, getattr, session.start, 'user')
+            self.assertEqual(hasattr(session.start, 'user'), False)
             session.start.user = USER
+            group_a = self.group.create({
+                    'name': 'Group A',
+                    })
+            group_b = self.group.create({
+                    'name': 'Group B',
+                    })
             session.start.groups = [
-                {'name': 'Group A'},
-                {'name': 'Group B'},
+                group_a,
+                group_b,
                 ]
-            session.save()
-            session = Session(self.wizard, session_id)
+            session._save()
+            session = self.wizard(session_id)
+            self.assertEqual(session.start.id, None)
             self.assertEqual(session.start.name, 'Test')
             self.assertEqual(session.start.user.id, USER)
             self.assertEqual(session.start.user.login, 'admin')
diff -r f6ef988fda71 trytond/tests/test_workflow.py
--- a/trytond/tests/test_workflow.py	Fri Sep 21 16:04:02 2012 +0200
+++ b/trytond/tests/test_workflow.py	Sun Sep 23 17:30:03 2012 +0200
@@ -12,23 +12,21 @@
 
     def setUp(self):
         install_module('test')
-        self.workflow_obj = POOL.get('test.workflowed')
+        self.workflow = POOL.get('test.workflowed')
 
     # TODO add test for Workflow.transition
     def test0010transition(self):
         'Test transition'
         with Transaction().start(DB_NAME, USER, context=CONTEXT):
-            wkf_id = self.workflow_obj.create({})
+            wkf = self.workflow.create({})
 
-            self.workflow_obj.run([wkf_id])
-            self.assertEqual(self.workflow_obj.read(wkf_id)['state'],
-                'running')
+            self.workflow.run([wkf])
+            self.assertEqual(wkf.state, 'running')
 
-            self.workflow_obj.write(wkf_id, {
-                    'state': 'end',
-                    })
-            self.workflow_obj.run([wkf_id])
-            self.assertEqual(self.workflow_obj.read(wkf_id)['state'], 'end')
+            wkf.state = 'end'
+            wkf.save()
+            self.workflow.run([wkf])
+            self.assertEqual(wkf.state, 'end')
 
 
 def suite():
diff -r f6ef988fda71 trytond/tools/__init__.py
--- a/trytond/tools/__init__.py	Fri Sep 21 16:04:02 2012 +0200
+++ b/trytond/tools/__init__.py	Sun Sep 23 17:30:03 2012 +0200
@@ -6,3 +6,8 @@
     from collections import OrderedDict
 except ImportError:
     from .ordereddict import OrderedDict
+
+
+class ClassProperty(property):
+    def __get__(self, cls, owner):
+        return self.fget.__get__(None, owner)()
diff -r f6ef988fda71 trytond/transaction.py
--- a/trytond/transaction.py	Fri Sep 21 16:04:02 2012 +0200
+++ b/trytond/transaction.py	Sun Sep 23 17:30:03 2012 +0200
@@ -79,6 +79,7 @@
         self.delete_records = {}
         self.delete = {}
         self.timestamp = {}
+        self.counter = 0
         return _TransactionManager()
 
     def stop(self):
